/********************************************************************************
*                                                                               *
*                      F X   M O V I E   M A N A G E R                          *
*                                                                               *
*********************************************************************************
* Copyright(C) 2008,2015 by Luigi Ziviani <ziviani_luigi@yahoo.it>.             *
* All Rights Reserved.                            version 6.7                   *
*********************************************************************************
* Id: fxtxtview.h,                                2005/01/01                    *
*********************************************************************************
* This file is part of FXMOVIEMANAGER                                           *
*                                                                               *
* FXMOVIEMANAGER is free software; you can redistribute it and/or modify        *
* it under the terms of the GNU General Public License as published by          *
* the Free Software Foundation; either version 3 of the License, or             *
* (at your option) any later version.                                           *
*                                                                               *
* FXMOVIEMANAGER is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
* GNU General Public License for more details.                                  *
*                                                                               *
* You should have received a copy of the GNU General Public License             *
* along with this program; if not, write to the Free Software                   *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA     * 
********************************************************************************/

#ifndef TXTCRYPT_H
#define TXTCRYPT_H

#include "fxmmKeyDialog.h"

class TextEncryptor : public FXMainWindow
{
    FXDECLARE(TextEncryptor)
protected:
    FXIcon 			*logoicon;
    FXIcon 			*logominiicon;			// Icons

    FXIcon			*abouticon;
    FXIcon			*allicon;
    FXIcon 			*buildicon;
    FXIcon 			*build2icon;
    FXIcon 			*conficon;
    FXIcon 			*copyicon;
    FXIcon 			*cuticon;
    FXIcon 			*deleteicon;
    FXIcon 			*exiticon;
    FXIcon			*fontsicon;
    FXIcon 			*newicon;
    FXIcon 			*openicon;
    FXIcon 			*pasteicon;
    FXIcon 			*printicon;
    FXIcon			*undoicon;
    FXIcon			*redoicon;
    FXIcon 			*saveicon;
    FXIcon 			*saveasicon;
    FXIcon 			*searchicon;
    FXIcon 			*searchagainicon;
    FXIcon 			*txtcrypticon;

  FXVerticalFrame*   globalframe;
  FXHorizontalFrame* tabcontents;
  FXHorizontalFrame* tab1frame;
  FXHorizontalFrame* tab2frame;
  FXHorizontalFrame* tab3frame;
  FXHorizontalFrame* tab4frame;
  FXTabBook*         tabbook;
  FXTabItem*         tab1;
  FXTabItem*         tab2;
  FXTabItem*         tab3;
  FXTabItem*         tab4;

  FXPacker* packer;

    FXButton			*button_new;
    FXButton			*button_open;
    FXButton			*button_save;
    FXButton			*button_saveas;
    FXButton			*button_print;
    FXButton			*button_quit;

    FXButton			*button_undo;
    FXButton			*button_redo;
    FXButton			*button_cut;
    FXButton			*button_copy;
    FXButton			*button_paste;
    FXButton			*button_delete;

    FXButton			*button_find;
    FXButton			*button_finda;
    FXButton			*button_setkey;
    FXButton			*button_encrypt;
    FXButton			*button_decrypt;

    FXButton			*button_font;
    FXButton			*button_about;
    FXButton			*button_help;

    FXMenuBar			*menubar;			// Menu bar
    FXMenuPane			*filemenu;			// File menu
    FXMenuPane			*editmenu;			// Edit menu
    FXMenuPane			*searchmenu;		// Search menu
    FXMenuPane			*prefsmenu;			// Preferences menu
    FXMenuPane			*cryptmenu;			// Cryptography menu
    FXMenuPane			*helpmenu;			// Help menu
    FXMenuPane          *popupmenu;         // Popup menu

    FXHorizontalFrame	*contents;			// Sunken border for text widget
    FXHorizontalFrame   *undoredoblock;     // Undo/redo block on status line

    FXToolBar			*toolbar;			// Toolbar
    FXText              *editor;            // Multiline text widget
    FXStatusBar			*statusbar;			// Status bar
    FXString			filename;			// File being edited
    FXbool              filenameset;        // Filename is set
    FXTextField			*text;
    FXUndoList          undolist;           // Undo list
    FXFont              *textfont;          // Text window font
    FXFont              *menufont;          // mmenu font
    FXString 			fontspec_t;			// Text window font
    FXString			fontspec_m;			// mmenu font

    FXMenuTitle 		*title_file;
    FXMenuTitle 		*title_edit;
    FXMenuTitle 		*title_search;
    FXMenuTitle 		*title_pref;
    FXMenuTitle 		*title_crypt;
    FXMenuTitle 		*title_help;

    FXMenuCheck 		*check_tabbook;
    FXMenuCheck 		*check_menubar;
    FXMenuCheck 		*check_toolbar;
    FXMenuCheck 		*check_statusbar;

    FXMenuCommand		*cmd_new;
    FXMenuCommand		*cmd_open;
    FXMenuCommand		*cmd_save;
    FXMenuCommand		*cmd_savea;
    FXMenuCommand		*cmd_print;
    FXMenuCommand		*cmd_quit;
    FXMenuCommand		*cmd_undo;
    FXMenuCommand		*cmd_redo;
    FXMenuCommand		*cmd_cut;
    FXMenuCommand		*cmd_copy;
    FXMenuCommand		*cmd_paste;
    FXMenuCommand		*cmd_delete;
    FXMenuCommand		*cmd_pcut;
    FXMenuCommand		*cmd_pcopy;
    FXMenuCommand		*cmd_ppaste;
    FXMenuCommand		*cmd_pdelete;
    FXMenuCommand		*cmd_all;
    FXMenuCommand		*cmd_find;
    FXMenuCommand		*cmd_finda;
    FXMenuCommand		*cmd_font;
    FXMenuCommand		*cmd_key;
    FXMenuCommand		*cmd_encrypt;
    FXMenuCommand		*cmd_decrypt;
    FXMenuCommand		*cmd_about;
    FXMenuCommand		*cmd_help;


    FXbool          	keyfileset;             // Key Filename is set
    FXbool              stripcr;                // Strip carriage returns

    FXColor 	theme_fxmmbase;
    FXColor 	theme_fxmmborder;
    FXColor 	theme_fxmmfore;
    FXColor 	theme_fxmmselfore;
    FXColor 	theme_fxmmmenufore;
    FXColor 	theme_fxmmtipfore;
    FXColor 	theme_fxmmback;
    FXColor 	theme_fxmmselback;
    FXColor 	theme_fxmmmenuback;
    FXColor 	theme_fxmmtipback;
    FXColor 	theme_fxmmhilite;
    FXColor 	theme_fxmmshadow;

    FXString	language;

    FXString    menu_op;
    FXString    menu_cu;
    FXString    menu_co;
    FXString    menu_pa;
    FXString    menu_de;
    FXString    menu_al;

    FXString    menu_ne;
    FXString    menu_ss;
    FXString    menu_sa;
    FXString    menu_pd;
    FXString    menu_qu;
    FXString    menu_ff;
    FXString    menu_fa;
    FXString    menu_fo;
    FXString    menu_cf;
    FXString    menu_en;


protected:
    fxmmKeyDialog		*keydialog;			    // the class keydialog.h
    FXString setKey(FXString& password);
    // save file
    FXbool saveFile(const FXString& file);
    // encrypt file
    FXbool encryptFile2();
    FXbool decryptFile2();
    FXString alfabeto;
    FXString password;
    FXPrinter printer;

protected:
  enum{
    MAXUNDOSIZE    = 1000000,               // Don't let the undo buffer get out of hand
    KEEPUNDOSIZE   = 500000                 // When MAXUNDOSIZE was exceeded, trim down to this size
    };

protected:
    TextEncryptor()
    {}

public:
    long onCmdAbout(FXObject*,FXSelector,void*);
    long onCmdHelp(FXObject*,FXSelector,void*);
    long onCmdNew(FXObject*,FXSelector,void*);
    long onCmdOpen(FXObject*,FXSelector,void*);
    long onCmdSave(FXObject*,FXSelector,void*);
    long onUpdSave(FXObject*,FXSelector,void*);
    long onCmdSaveAs(FXObject*,FXSelector,void*);
    long onCmdSetKey(FXObject*,FXSelector,void*);
    long onCmdEncrypt2(FXObject*,FXSelector,void*);
    long onCmdDecrypt2(FXObject*,FXSelector,void*);
    long onCmdQuit(FXObject*,FXSelector,void*);
    long onCmdFind(FXObject*,FXSelector,void*);
    long onCmdPrint(FXObject*,FXSelector,void*);
    long onCmdFont(FXObject*,FXSelector,void*);
    long onTextRightMouse(FXObject*,FXSelector,void* ptr);
    long onUpdMenu(FXObject* sender,FXSelector,void*);
    long onUpdTitle(FXObject* sender,FXSelector,void*);
    long onTextInserted(FXObject*,FXSelector,void* ptr);
    long onTextDeleted(FXObject*,FXSelector,void* ptr);
    long onTextReplaced(FXObject*,FXSelector,void* ptr);
    long onTextChanged(FXObject* sender,FXSelector,void*);

public:
    enum{
        ID_ABOUT=FXMainWindow::ID_LAST,
        ID_PANEL,
        ID_HELP,
        ID_MTX,
        ID_NEW,
        ID_OPEN,
        ID_SAVE,
        ID_SAVEAS,
        ID_SETKEY,
        ID_ENCRYPT2,
        ID_DECRYPT2,
        ID_TITLE,
        ID_FIND,
        ID_FIND_AGAIN,
        ID_QUIT,
        ID_PRINT,
        ID_FONT,
        ID_TEXT,
        ID_LAST
    };

public:
    TextEncryptor(FXApp* a);
    virtual void create();
    void saveConfig();
    void setPrinter();
    FXbool readConfig();
    FXbool isModified() const;
    FXbool saveChanges();
    FXbool loadFile(const FXString& file);
    FXint find(const FXString,FXint);
    virtual ~TextEncryptor();
};
#endif

